﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Data;

using C1.Silverlight.DataGrid.Excel;
using C1.Silverlight.DataGrid;

namespace SL_DataGrid_ExportTranslatedValues
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = new NameList();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {            
            var options = new ExcelSaveOptions()
            {
                FileFormat = ExcelFileFormat.Xlsx, 
                KeepColumnWidths = true,
                KeepRowHeights = true,
                CollapsibleGroups = true
            };

            var excelExt = options.FileFormat.ToString();

            var dialog = new System.Windows.Controls.SaveFileDialog()
            {
                DefaultExt = "*." + excelExt,
                Filter = "Excel " + excelExt + " (*." + excelExt + ")|*." + excelExt + "|All files (*.*)|*.*",
            };

            if (dialog.ShowDialog() == false) return;

            using (var stream = dialog.OpenFile())
            {
                _dataGrid.Save(stream, options);
            }

        }

        private void DataGridTemplateColumn_GettingCellValue(object sender, DataGridGettingCellValueEventArgs e)
        {
            e.Value = ((System.Windows.Controls.TextBlock)(e.Row.Presenter[_dataGrid.Columns[4]].Content)).Text;
        }
    }

    public class NameList : ObservableCollection<PersonName>
    {
        public NameList()
            : base()
        {
            for (int i = 1; i < 200; i++)
                Add(new PersonName("Fname" + i.ToString(), "Lname" + i.ToString()));
        }
    }

    public class PersonName
    {
        private string firstName;
        private string lastName;
        private bool _check;

        public PersonName(string first, string last)
        {
            this.firstName = first;
            this.lastName = last;
            this._check = false;
        }

        public bool Checked
        {
            get { return _check; }
            set { _check = value; }
        }

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }

        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }
    }

    public class BoolTextConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value.ToString() == "False")
                return "No";
            else
                return "Yes";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }
}
